<template>
  <div>
    <div class="inner--headers">
      <h2>{{ pageId }}</h2>
      <div class="bread--crumbs--wrap">
        <span>홈</span>
        <span>이벤트 관리</span>
        <span>{{ pageId }}</span>
      </div>
    </div>

    <div class="search--modules">
      <div class="form--cont--filter">
        <v-select
          v-model="filter"
          :items="filterArr"
          variant="outlined"
          class="custom-select"
        >
        </v-select>
      </div>
      <div class="form--cont--text">
        <v-text-field
          v-model="searchModel"
          class="custom-input mini"
          style="width: 100%"
          placeholder="검색어를 입력하세요"
        ></v-text-field>
      </div>
      <v-btn
        class="custom-btn btn-blue mini sch--btn"
        @click="fnSearch(searchModel, filter)"
        >검색</v-btn
      >
    </div>

    <div class="data--list--wrap">
      <div class="tbl-wrapper">
        <div class="tbl-wrap">
          <!-- ag grid -->
          <ag-grid-vue
            style="width: 100%; height: calc(10 * 2.94rem)"
            class="ag-theme-quartz"
            :gridOptions="gridOptions"
            :rowData="tblItems"
            :paginationPageSize="pageObj.pageSize"
            :suppressPaginationPanel="true"
            @grid-ready="onGridReady"
            @rowClicked="detailLocated"
          >
          </ag-grid-vue>

          <!-- 페이징 -->
          <div class="ag-grid-custom-pagenations">
            <pagination @chg_page="chgPage" :pageObj="pageObj"></pagination>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { AgGridVue } from "ag-grid-vue3";
  import pagination from "../components/common/pagination.vue";
  /************************************************************************
|    레이아웃
************************************************************************/
  definePageMeta({
    layout: "default",
  });
  /************************************************************************
|   PROPS
 ************************************************************************/
  const props = defineProps({
    propsData: {
      type: Object,
      default: () => {},
    },
  });
  /************************************************************************
|    스토어
 ************************************************************************/
  const useDtStore = useDetailStore();
  /************************************************************************
|    전역
 ************************************************************************/
  const searchModel = ref("");
  const filter = ref("");
  const filterArr = ref([
    { title: "선택하세요", value: "" },
    { title: "제목", value: "title" },
  ]);
  const { $toast, $log, $dayjs, $eventBus } = useNuxtApp();
  const router = useRouter();
  const pageId = ref("마감된 이벤트");
  let pageObj = ref({
    page: 1, // 현재 페이지
    pageMaxNumSize: 10, // 페이지 숫자 최대 표현 개수
    pageSize: 10, // 테이블 조회 데이터 개수
    totalCnt: 0, // 전체 페이지
  });
  const tblItems = ref([]); // stat 데이터

  /* eslint-disable */
  /* prettier-ignore */

  pageObj.value.totalCnt = tblItems.value.length;

  const remToPx = () => parseFloat(getComputedStyle(document.documentElement).fontSize);
  const rowHeightRem = 2.65; // 원하는 rem 값
  const rowHeightPx = rowHeightRem * remToPx();
  const gridApi = shallowRef();

  // gridOption
  const gridOptions = {
    columnDefs: [
      {
        headerName: "No",
        valueGetter: (params) => params.api.getDisplayedRowCount() - params.node.rowIndex,
        sortable: false,
        width: 70,
      },
      { headerName: "제목", field: "TITLE", sortable: false },
      {
        headerName: "기간",
        field: "STARTDATE",
        sortable: false,
        cellRenderer: (params) => {
          const formatDate = (str) => {
            if (!str) return "";
            const d = new Date(str);
            const yyyy = d.getFullYear();
            const mm = String(d.getMonth() + 1).padStart(2, "0");
            const dd = String(d.getDate()).padStart(2, "0");
            return `${yyyy}-${mm}-${dd}`;
          };

          const start = formatDate(params.data.STARTDATE);
          const end = formatDate(params.data.ENDDATE);

          return `${start} ~ ${end}`;
        },
      },
      {
        headerName: "상태",
        field: "STATUS",
        sortable: false,
        width: 70,
        cellRenderer: (params) => {
          return params.value == 0 ? "대기중" : params.value == 1 ? "진행중" : "마감";
        },
      },
      { headerName: "등록일", field: "REGDATE", sortable: false, width: 140 },
      // {
      //   headerName: "알림 메일 수신 여부",
      //   field: "mail_recp_yn",
      //   sortable: false,
      //   width: 130,
      // },
    ],
    rowData: tblItems.value, // 테이블 데이터
    autoSizeStrategy: {
      type: "fitGridWidth", // width맞춤
    },
    suppressMovableColumns: true,
    headerHeight: rowHeightPx,
    rowHeight: rowHeightPx,
    pagination: true,
    suppressPaginationPanel: true, // 하단 default 페이징 컨트롤 숨김
    //rowSelection: {
    // checkboxes: true,
    // headerCheckbox: true,
    // enableClickSelection: false,
    // mode: "multiRow",
    //},
  };

  /************************************************************************
|    함수(METHODS)
************************************************************************/
  const onGridReady = (__PARAMS) => {
    gridApi.value = __PARAMS.api;
  };

  const chgPage = (__PAGE) => {
    pageObj.value.page = __PAGE;
    gridApi.value.paginationGoToPage(__PAGE - 1);
  };

  const addLocated = () => {
    router.push({
      path: "/view/event/evtAdd",
    });
    useDtStore.boardInfo.pageType = "I";
  };

  const detailLocated = (__EVENT) => {
    router.push({
      path: "/view/event/evtAdd",
    });
    useDtStore.boardInfo.seq = __EVENT.data.SEQ;
    useDtStore.boardInfo.pageType = "U";
    useDtStore.boardInfo.status = "2";
  };

  const evtListGet = () => {
    let _req = {
      compId: useAuthStore().getCompanyId,
      status: "2",
    };

    useAxios()
      .post("/evt/list", _req)
      .then((res) => {
        _req._size = res.data.length;
        tblItems.value = res.data;
        pageObj.value.totalCnt = tblItems.value.length;
      });
  };

  const fnSearch = (__KEYWORD, __FILTER) => {
    let _req = {
      compId: useAuthStore().getCompanyId,
      filter: __FILTER,
      keyword: __KEYWORD,
      status: "2",
      // _size: 1000,
      // _index: 0,
      // admin_name:
      //   __FILTER == "admin_name" ? __KEYWORD : __FILTER == "" ? __KEYWORD : null,
      // id: __FILTER == "id" ? __KEYWORD : __FILTER == "" ? __KEYWORD : null,
    };

    useAxios()
      .post("/evt/search", _req)
      .then((res) => {
        _req._size = res.data.length;

        tblItems.value = res.data;
        pageObj.value.totalCnt = tblItems.value.length;
      })
      .catch((error) => {});
  };

  /************************************************************************
|    WATCH
************************************************************************/

  watch(
    () => props,
    () => {
      searchObj.value = props.propsData;
      fnGetStat();
    },
    { deep: true }
  );

  onMounted(() => {
    evtListGet();
  });
</script>
